<?php

include_once($_SESSION['sys']['basedir'].'/lib/overview_utils.php');

if (empty($_SESSION['overview_kosten.year'])) $_SESSION['overview_kosten.year'] = 0;

$details = <<<EOC
<div style="padding-left: 3px; margin-top: -10px;">
<b>Gebiet</b>: <span id="detail_gebiet"></span><br>
<b>Gewässer</b>: <span id="detail_kostenstelle"></span><br>
<b>Länge</b>: <span id="detail_laenge"></span><br>
<b>Gesamtkosten</b>: <span id="detail_gewaesserkosten"></span><br>
<b>Personalkosten</b>: <span id="detail_personalkosten"></span><br>
<b>Gerätekosten</b>: <span id="detail_geraetekosten"></span><br>
<b>Gewässer gereinigt</b>: <span id="detail_gereinigt"></span>
</div>
EOC;

$mask = array(
	      'table' => 'einsatz',
	      'title' => 'Kostenaufwand für Kostenstellen',
	      'join' => array(
			      'einsatzpersonal ON einsatzpersonal.einsatz = einsatz.id',
			      'einsatzgeraete ON einsatzgeraete.einsatz = einsatz.id',
			      'personal ON einsatzpersonal.personal = personal.id',
			      'gerate ON einsatzgeraete.geraet = gerate.id',
			      'anbaugeraete ON einsatzgeraete.anbaugeraet = anbaugeraete.id',
			      'arbeitsarten ON einsatz.arbeiten = arbeitsarten.id',
			      'gebiet ON einsatz.gebiet = gebiet.id',
			      'kostenstellen ON einsatz.kostenstelle = kostenstellen.id',
			      ),
	      'where' => "arbeitsarten.arbeitsart <> 'Urlaub' AND arbeitsarten.arbeitsart <> 'Krank' AND arbeitsarten.arbeitsart <> 'Sonstige Fehltage'"
		       . " AND date_part('year', datum) = " . $_SESSION['overview_kosten.year'],
	      'select' => array(
				'title' => 'Auswahl',
				'options' => discover_years(),
				'default' => 'Jahr wählen',
				'selected' => $_SESSION['overview_kosten.year'],
				'onchange' => "setvar(this,'year',select_year_calback,select_year_status)",
				),
	      'variables' => array(
				   'year' => array(),
				   ),
 	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    'width' => 60,
					    'sql' => 'einsatz.id',
					    ),
			      'datum' => array(
					    'name' => 'Datum',
					    'type' => 'date',
					    'width' => 70,
					    ),
			      'gebiet' => array(
					    'name' => 'Gebiet',
					    'sql' => "gebiet.gebiet",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'kostenstelle' => array(
					    'name' => 'Kostenstelle',
					    'sql' => "kostenstellen.kostenstelle",
					    'width' => 250,
					    'specs' => "filterUI: 's'",
					    ),
			      'arbeitsart' => array(
					    'name' => 'Arbeiten',
					    'sql' => "arbeitsarten.arbeitsart",
					    'width' => 250,
					    'specs' => "filterUI: 's'",
					    ),
			      'personal' => array(
					    'name' => 'Mitarbeiter',
					    'sql' => "personal.name || ', ' || personal.vorname",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'geraet' => array(
					    'name' => 'Gerät',
					    'sql' => "gerate.geraet",
					    'width' => 150,
					    'specs' => "filterUI: 's'",
					    ),
			      'laenge' => array(
					    'name' => 'Länge',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 70,
					    ),
			      'personalkosten' => array(
					    'name' => 'Mitarbeiterkosten',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 90,
					    'sql' => 'einsatzpersonal.stunden * personal.persstdsatz',
					    ),
			      'geraetkosten' => array(
					    'name' => 'Gerätkosten',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 90,
					    'sql' => 'einsatzgeraete.stunden * gerate.geraetkst_intern + ' .
						     'einsatzgeraete.stunden * anbaugeraete.anbkst_intern',
					    ),
			      'gesamtkosten' => array(
					    'name' => 'Gesamtkosten',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 90,
					    'sql' => 'einsatzpersonal.stunden * personal.persstdsatz + ' . 
						     'einsatzgeraete.stunden * gerate.geraetkst_intern + ' .
						     'einsatzgeraete.stunden * anbaugeraete.anbkst_intern',
					    ),
			      'prolfdm' => array(
					    'name' => 'pro lfdm',
					    'type' => 'number',
					    'specs' => "decPlaces: 2, ClassName: 'alignright', suffix: '&nbsp;', canSort: false",
					    'width' => 60,
					    'sql' => '(einsatzpersonal.stunden * personal.persstdsatz + ' . 
						     'einsatzgeraete.stunden * gerate.geraetkst_intern + ' .
						     'einsatzgeraete.stunden * anbaugeraete.anbkst_intern) / laenge',
					    ),
			      ),
 	      'details' => array(
				 'html' => $details,
				 'list' => array(
						 'gebiet' => array('fetch' => fetch_gebiet),
						 'kostenstelle' => array('fetch' => fetch_kostenstelle),
						 'laenge' => array('fetch' => fetch_laenge),
						 'gewaesserkosten' => array('fetch' => fetch_gewaesserkosten),
						 'personalkosten' => array('fetch' => fetch_personalkosten),
						 'geraetekosten' => array('fetch' => fetch_geraetekosten),
						 'gereinigt' => array('fetch' => fetch_gereinigt),
						 ),

			      ),
	      );

function fetch_gebiet()
{
  $sql = 'SELECT gebiet.gebiet FROM gebiet JOIN einsatz ON einsatz.gebiet = gebiet.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['gebiet'];
}

function fetch_kostenstelle()
{
  $sql = 'SELECT kostenstellen.kostenstelle FROM kostenstellen JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['kostenstelle'];
}

function fetch_laenge()
{
  $sql = 'SELECT laenge FROM kostenstellen JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id WHERE einsatz.id = ' . intval($_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['laenge'] . ' m';
}

function fetch_gewaesserkosten()
{
  $sql = <<<EOC
  SELECT sum(stunden * persstdsatz) AS gesamt
  FROM einsatzpersonal
  JOIN personal ON einsatzpersonal.personal = personal.id
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);
  $pkosten = query_db($sql);
  if ($pkosten === false) return '';

  $sql = <<<EOC
  SELECT sum(stunden * gerate.geraetkst_intern +
             stunden * anbaugeraete.anbkst_intern) AS gesamt
  FROM einsatzgeraete
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);
  $gkosten = query_db($sql);
  if ($gkosten === false) return '';

  return sprintf('%.2f &euro;', $pkosten[0]['gesamt'] + $gkosten[0]['gesamt']);
}

function fetch_personalkosten()
{
  $sql = <<<EOC
  SELECT sum(stunden * persstdsatz) AS gesamt
  FROM einsatzpersonal
  JOIN personal ON einsatzpersonal.personal = personal.id
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return sprintf('%.2f &euro;', $res[0]['gesamt']);
}

function fetch_geraetekosten()
{
  $sql = <<<EOC
  SELECT sum(stunden * gerate.geraetkst_intern +
             stunden * anbaugeraete.anbkst_intern) AS gesamt
  FROM einsatzgeraete
  WHERE einsatz IN
    (SELECT id FROM einsatz WHERE date_part('year', datum) = %d AND kostenstelle =
    (SELECT kostenstelle FROM einsatz WHERE id = %d))
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);
  $res = query_db($sql);
  if ($res === false) return '';

  return sprintf('%.2f &euro;', $res[0]['gesamt']);
}

function fetch_gereinigt()
{
  $sql = <<<EOC
  SELECT count(*) AS count
  FROM gereinigt
  JOIN kostenstellen ON gereinigt.kostenstelle = kostenstellen.id
  JOIN einsatz ON einsatz.kostenstelle = kostenstellen.id
  WHERE jahr = %d AND einsatz.id = %d
EOC;

  $sql = sprintf($sql, $_SESSION['overview_kosten.year'], $_POST['id']);

  $res = query_db($sql);
  if ($res === false) return '';

  return $res[0]['count'] == 0 ? 'nein' : 'ja';
}

?>
